<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 99</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 99: relecture du papier 9</H1>

<P>
Numéro du papier: 9

<P>Nom du papier et auteurs: Construction incrémentielle distribuée
    de programmes déclaratifs,
<P>    Olivier Michel, Jean-Louis Giavitto

<H2>1</H2>

<P>
Nom du rapporteur: Jean Goubault-Larrecq

<P>Confiance en la note: (de 1 à 3) 2
<P> (1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.)

<P>Notation du papier: (de 1 à 5) 2
<P> (1: à rejeter; 2: inintéressant; 3: acceptable;
<P>  4: bon papier; 5: très bon papier)

<P>Commentaires aux auteurs:
<P>    Cet article propose une modélisation d'un langage
déclaratif original, très proche de 8 1/2.  Malheureusement,
les auteurs ne semblent pas dominer l'aspect formel des
définitions mathématiques, et donnent des interprétations
intuitives de leurs règles de sémantique que tendent à
contredire les règles elles-mêmes.
<P>    En ce qui concerne les notations, on ne peut que remarquer
le caractère extrêmement ambigu des points de suspension
dans les règles $\{...\}$ et $\#_1$ de la figure 5.  Le lecteur
ne devrait pas à faire preuve d'imagination pour savoir ce que
des règles de sémantique acceptent ou refusent comme
exécutions valides.
<P>    Si l'on prend les règles de la figure 5 une à une, on remarque :
<P>- dans les règles $Ref^n$ à $\cdot S_3$, il manque un $\Gamma$
    à gauche;
<P>- $Ref^n$ : dans les cas o\`u $x^n$ est indéfini, la règle
    permet de réduire $x^n$ en ${\mathtt bind} ({\mathtt tl}^n (\rho),
    x^n)$, qui vaut $x^n$; cette règle autorise donc des boucles
    infinies dans l'évaluation des variables.  Outre le fait que ce n'est
    probablement pas l'intention des auteurs, cela détruit l'intérêt
    de la restriction $n_i \in \{0,1\}, \sum n_i \geq 1$ de la règle
$\{...\}$.
    En effet, tout terme contenant au moins une variable peut se réduire
    en une étape en lui-même.
<P>- $\#_1$ : est à réécrire complètement;
<P>- $@_1$: il manque la condition de bord $e\in {\mathrm Dom} \rho'$,
    sinon les prémisses n'ont pas de sens;
<P>- $\%_1$, $?_1$ : il manque la condition $C (\rho', e'')$, sinon
    l'évaluation dans l'environnement distant est autorisée à
    s'arrêter à n'importe quel moment, y compris avant d'avoir
    atteint une forme normale;
<P>- règles $@_1$ à $?_2$ : je prétends que les conditions
    $\wedge C (\rho, e')$, et les conditions $\lor \neg C (\rho, e')$
    sont inutiles.  Pour cela, regardons la définition de $C$ en p.21:
    $C (\rho, ref)$ n'est pas défini; si on le définit comme étant
    $true$, alors les conditions mentionnées ci-dessus sont
    inutiles, car subsumées par $e' \in REF$, resp.\ $e' \not\in REF$.

<P>    En fait, les définitions de l'annexe A sont compliquées
(inutilement, je l'espère), partielles et parfois incorrectes.
En premier, $Nenv$ est une fonction indéfinie lorsque son
deuxième argument est de la forme $e_1 @ e_2$, $e_1 \% e_2$,
$e_1 ? e_2$ ou $ref$.  Ensuite, contrairement à ce que les
auteurs annoncent, les définitions de {\tt Nenv} et de {\tt C}
sont circulaires : les auteurs devraient réécrire la définition
pour faire dispara\^{\i}tre la circularité, ou pour exhiber
un principe de récurrence bien fondé.  Enfin, j'ai déjà
mentionné que la définition de $C$ était elle aussi partielle.
<P>    En p.10, ligne -2: c'est la fermeture transitive de $\to$ et
non $\to'_e$ qu'il faut utiliser pour évaluer $e$.
<P>    En p.14, l'explication de \% est incorrecte, dans la mesure o\`u,
même si $e''$ est la $(\Gamma, \rho')$-forme normale de $e$,
il se peut que $e''$ ne soit pas $(\Gamma, \rho)$-normal.  Il se peut
alors que la sémantique retourne une valeur qui n'est pas un
terme normal dans son contexte---ce qui est assez étrange.
<P>    En p.14, ligne -7: ``qui est égale à $arg^0 \cdot fct^0$'' : non,
à $F (x^0, arg^0 \cdot fct^0)$.
<P>    En p.20, définition 4: $\Gamma \in {\cal E}_{LOC} :'', le
deux-points devrait être un signe égale.


<P>Commentaires réservés au comité de programme:


<H2>2</H2>

<P>Nom du rapporteur: Laurent Dami

<P>Confiance en la note: (de 1 à 3) 3
<P> (1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.)

<P>Notation du papier: (de 1 à 5) 2.5
<P> (1: à rejeter; 2: inintéressant; 3: acceptable;
<P>  4: bon papier; 5: très bon papier)

<P>Commentaires aux auteurs:



<P>Il est toujours enthousiasmant de modifier des structures ou d'en
concevoir de nouvelles. Ici les auteurs "inventent" la notion
d'"amalgame", en réalité une structure proche des "environnements"
bien connus en sémantique dénotationnelle, ou encore proche des
enregistrements récursifs utilisés pour la modélisation des langages
orientés-objets. En soi la démarche est tout à fait louable, et la
présentation est séduisante, mais les auteurs pèchent par manque de
références aux travaux antérieurs, et par manque de rigueur dans
l'examen des conséquences des constructions proposées.

<P>Les travaux de Jagannathan, les Mobile Ambients de Cardelli/Gordon
sont bien cités en référence, mais sans aucune discussion dans le
texte, ce qui rend la référence inutile.

<P>Il semble y avoir une notion implicite de système "valide" ou "bien
formé", mais celle-ci n'est pas définie ouvertement.

<P>Les règles d'évaluation manquent, ce qui ne permet pas d'apprécier 
les diverses options de distribution ni les phrases du syle "évalué en
premier". Il me semble que le langage n'est pas confluent
(Church-Rosser): par exemple avec l'amalgame

<P>        {a=b, b=2, c={x=a, b=3}}

<P>on peut obtenir pour x la valeur 2 ou 3 selon l'ordre dans lequel on
opère les substitutions. 

<P>Les propriétés des opérateurs sont également confuses: par exemple on
attendrait d'un opérateur de concaténation qu'il soit commutatif et
associatif, mais je doute que ce soit le cas ici (en tout cas pour
l'associativité). 

<P>L'opérateur d'échappement fait immédiatement penser à un indice de de
Bruijn; mais alors il faut une mécanique de recalculs d'indices en
cours d'évaluation (cf calculs de substitutions explicites).

<P>Pour la localisation des expressions, le domaine des "sites"
n'apparaît pas dans la définition du langage en 3.1. Pas clair,
surtout en regard du commentaire en bas de p13: "une référence,
c'est-à-dire une localisation" ...??

<P>p10, 3 lignes avant la fin, erreur LaTex:<BR>
        la la flèche e-&gt;e' devrait être e-&gt;&gt;e'


</BODY>
</HTML>
